<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>CRUD Pizza365 Page</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <!-- Tempusdominus Bootstrap 4 -->
  <link rel="stylesheet" href="plugins/tempusdominus-bootstrap-4/css/tempusdominus-bootstrap-4.min.css">
  <!--- DataTable-->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">

</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Contact</a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">AdminLTE 3</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">Admin Pham Dac Thanh</a>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Danh Sách Admin Page
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="CRUD_pizza365.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>CRUD Pizza365</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index2.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Dashboard v2</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index3.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Dashboard v3</p>
                </a>
              </li>
            </ul>
          </li>
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>CRUD Pizza365</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">CRUD Pizza365</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
        <div class="container">
          <h2 style="text-align: center;">Danh sách đơn hàng</h2>
          <div class="container">
            <div class="row form-group">
              <div class="col-sm-4">
                <div class="row">
                  <div class="col-sm-4">
                    <label for="firstName">Order Status</label>
                  </div>
                  <div class="col-sm-8">
                    <select type="text" class="form-control" id="inp-order-status">
                      <option value="0">(all)</option>
                      <option value="open">open</option>
                      <option value="confirmed">confirmed</option>
                      <option value="cancel">cancel</option>
                    </select>
                  </div>
                </div>
              </div>
              <div class="col-sm-4">
                <div class="row">
                  <div class="col-sm-4">
                    <label for="LastName">Loại Pizza</label>
                  </div>
                  <div class="col-sm-8">
                    <select type="text" class="form-control" id="inp-loai-pizza">
                      <option value="0">(all)</option>
                      <option value="hawai">HAWAII</option>
                      <option value="bacon">BACON</option>
                      <option value="seafood">SEAFOOD</option>
                    </select>
                  </div>
                </div>
              </div>
              <div class="col-sm-4 ">
                <div>
                  <button class="btn btn-secondary btn-filter-order">Filter data</button>
                </div>
              </div>
            </div>
          </div>
          <div class="form-group">
            <button class="btn btn-success btn-add-order"><i class="fas fa-plus"></i>ADD</button>
          </div>
          <table class="table table-bordered table-striped table-hover" id="user-table">
            <thead>
              <tr>
                <th>order ID</th>
                <th>Kích Cỡ Combo</th>
                <th>loại Pizza</th>
                <th>Nước Uống</th>
                <th>Thành tiền</th>
                <th>Họ và tên</th>
                <th>Số điện thoại</th>
                <th>trạng thái</th>
                <th>Detail</th>
              </tr>
          </table>
        </div>
        
        <!-- modal detail  -->
        <div class="modal" tabindex="-1" role="dialog" id="modal-confirm-order">
          <div class="modal-dialog" role="document">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title">Edit order</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                </button>
              </div>
              <div class="modal-body">
                <div class="container">
                  <div class="form group">
                      <h1>Edit order !!</h1>
                  </div>
                  <div class="form group">
                      <label>order ID (mã đơn hàng)</label>
                      <input type="text" class="form-control" placeholder="..." id="inp-id-don-hang">
                  </div>
                  <div class="form group">
                      <label>Has Combo</label>
                      <input type="text" class="form-control" placeholder="..." id="inp-combo">
                  </div>
                  <div class="form group">
                      <label>diameter pizza</label>
                      <input type="text" class="form-control" placeholder="..." id="inp-diameter-pizza">
                  </div>
                  <div class="form group">
                      <label>sườn nướng (miếng)</label>
                      <input type="text" class="form-control" placeholder="..." id="inp-suon">
                  </div>
                  <div class="form group">
                      <label>đồ uống</label>
                      <input type="text" class="form-control" placeholder="..." id="inp-do-uong">
                  </div>
                  <div class="form group">
                      <label>số lượng đồ uống</label>
                      <input type="text" class="form-control" placeholder="..." id="inp-so-luong-do-uong">
                  </div>
                  <div class="form group">
                      <label>Vooucher ID</label>
                      <input type="text" class="form-control" placeholder="..." id="inp-voucher-id">
                  </div>
                  <div class="form group">
                      <label>loai Pizza</label>
                      <input type="text" class="form-control" placeholder="..." id="inp-loai-pizza">
                  </div>
                  <div class="form group">
                      <label>Salad</label>
                      <input type="text" class="form-control" placeholder="..." id="inp-salad">
                  </div>
                  <div class="form group">
                      <label>thành tiền</label>
                      <input type="text" class="form-control" placeholder="..." id="inp-prices">
                  </div>
                  <div class="form group">
                      <label>Dícount</label>
                      <input type="text" class="form-control" placeholder="..." id="inp-discount">
                  </div>
                  <div class="form group">
                      <label>họ và tên</label>
                      <input type="text" class="form-control" placeholder="..." id="inp-ho-ten">
                  </div>
                  <div class="form group">
                      <label>email</label>
                      <input type="text" class="form-control" placeholder="..." id="inp-email">
                  </div>
                  <div class="form group">
                      <label>Phone number</label>
                      <input type="text" class="form-control" placeholder="..." id="inp-phone">
                  </div>
                  <div class="form group">
                      <label>Địa Chỉ</label>
                      <input type="text" class="form-control" placeholder="..." id="inp-dia-chi">
                  </div>
                  <div class="form group">    
                      <label>lời nhắn</label>
                      <input type="text" class="form-control" placeholder="..." id="inp-loi-nhan">
                  </div>
                  <div class="form group">    
                      <label>Trạng thái đơn hàng</label>
                      <input type="text" class="form-control" placeholder="..." id="inp-status-cargo">
                  </div>
                  <div class="form group">    
                      <label>Ngày tạo đơn</label>
                      <input type="text" class="form-control" placeholder="..." id="inp-ngay-tao">
                  </div>
                  <div class="form group">    
                      <label>ngày cập nhật</label>
                      <input type="text" class="form-control" placeholder="..." id="inp-ngay-update">
                  </div>
              </div>
              </div>
              <div class="modal-footer">
                <button class="btn btn-danger" id="btn-cancel">Cancel</button>
                <button class="btn btn-dark" id="btn-confirm">Confirm</button>
              </div>
            </div>
          </div>
        </div>
          <!-- /.modal detail-->
        
        <!-- modal add -->
        <div class="modal" tabindex="-1" role="dialog" id="modal-add-order">
          <div class="modal-dialog" role="document">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title">Add New Order</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                </button>
              </div>
              <div class="modal-body">
                <div class="container">
                  <div class="form group">
                      <h1>Add Order !!</h1>
                  </div>
                  <div class="form group">
                      <label>order ID (mã đơn hàng)</label>
                      <input type="text" class="form-control" placeholder="..." id="inp-id-don-hang-add">
                  </div>
                  <div class="form group">
                      <label>Has Combo</label>
                      <select class="form-control" id="select-combo-add">
                        <option value="0">== select pizza size ==</option>
                        <option value="S">S</option>
                        <option value="M">M</option>
                        <option value="L">L</option>
                      </select>
                  </div>
                  <div class="form group">
                      <label>diameter pizza</label>
                      <input type="text" class="form-control" disabled placeholder="..." id="inp-diameter-pizza-add">
                  </div>
                  <div class="form group">
                      <label>sườn nướng (miếng)</label>
                      <input type="text" class="form-control" disabled placeholder="..." id="inp-suon-add">
                  </div>
                  <div class="form group">
                      <label>đồ uống</label>
                      <select class="form-control" id="select-do-uong-add">
        
                      </select>
                  </div>
                  <div class="form group">
                      <label>số lượng đồ uống</label>
                      <input type="text" class="form-control" disabled placeholder="..." id="inp-so-luong-do-uong-add">
                  </div>
                  <div class="form group">
                      <label>Vooucher ID</label>
                      <input type="number" class="form-control" placeholder="..." id="inp-voucher-id-add">
                  </div>
                  <div class="form group">
                      <label>loai Pizza</label>
                      <select class="form-control" id="select-loai-pizza-add">
                        <option value="0">== select pizza type ==</option>
                        <option value="Seafood">Hải sản</option>
                        <option value="Hawaii">Hawaii</option>
                        <option value="Bacon">Thịt Hun Khói</option>
                      </select>
                  </div>
                  <div class="form group">
                      <label>Salad</label>
                      <input type="text" class="form-control" disabled placeholder="..." id="inp-salad-add">
                  </div>
                  <div class="form group">
                      <label>thành tiền</label>
                      <input type="text" class="form-control" disabled placeholder="..." id="inp-prices-add">
                  </div>
                  <div class="form group">
                      <label>Dícount</label>
                      <input type="text" class="form-control" placeholder="..." id="inp-discount-add">
                  </div>
                  <div class="form group">
                      <label>họ và tên</label>
                      <input type="text" class="form-control" placeholder="..." id="inp-ho-ten-add">
                  </div>
                  <div class="form group">
                      <label>email</label>
                      <input type="text" class="form-control" placeholder="..." id="inp-email-add">
                  </div>
                  <div class="form group">
                      <label>Phone number</label>
                      <input type="number" class="form-control" placeholder="..." id="inp-phone-add">
                  </div>
                  <div class="form group">
                      <label>Địa Chỉ</label>
                      <input type="text" class="form-control" placeholder="..." id="inp-dia-chi-add">
                  </div>
                  <div class="form group">    
                      <label>lời nhắn</label>
                      <input type="text" class="form-control" placeholder="..." id="inp-loi-nhan-add">
                  </div>
                  <div class="form group">    
                      <label>Trạng thái đơn hàng</label>
                      <input type="text" class="form-control" placeholder="..." id="inp-status-cargo-add">
                  </div>
                  <!-- Date create order-->
                  <div class="form-group">
                    <label>Date create:</label>
                      <div class="input-group date" id="inp-ngay-tao-add" data-target-input="nearest">
                          <input type="text" class="form-control datetimepicker-input" data-target="#inp-ngay-tao-add"/>
                          <div class="input-group-append" data-target="#inp-ngay-tao-add" data-toggle="datetimepicker">
                              <div class="input-group-text"><i class="fa fa-calendar"></i></div>
                          </div>
                      </div>
                  </div>
                  <!-- Date update order-->
                  <div class="form-group">
                    <label>Date update</label>
                      <div class="input-group date" id="inp-ngay-update-add" data-target-input="nearest">
                          <input type="text" class="form-control datetimepicker-input" data-target="#inp-ngay-update-add"/>
                          <div class="input-group-append" data-target="#inp-ngay-update-add" data-toggle="datetimepicker">
                              <div class="input-group-text"><i class="fa fa-calendar"></i></div>
                          </div>
                      </div>
                  </div>
              </div>
              </div>
              <div class="modal-footer">
                <button class="btn btn-danger" id="btn-cancel-add" data-dismiss="modal">Cancel</button>
                <button class="btn btn-primary" id="btn-add">Add</button>
              </div>
            </div>
          </div>
        </div>
          <!-- /.modal add-->
        
        <!-- modal delete -->
        <div class="modal" tabindex="-1" role="dialog" id="modal-delete-order">
          <div class="modal-dialog" role="document">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title">Delete Order</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                </button>
              </div>
              <div class="modal-body">
                <p>Are you sure to delete this order</p>
              </div>
              <div class="modal-footer">
                <button type="button" class="btn btn-primary btn-yes">yes</button>
                <button type="button" class="btn btn-danger btn-no" data-dismiss="modal">No</button>
              </div>
            </div>
          </div>
        </div>
          <!-- /.modal delete -->
      
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 3.2.0
    </div>
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong> All rights reserved.
  </footer>

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
</div>
<!-- ./wrapper -->
</body>

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<!-- Tempusdominus Bootstrap 4 -->
<script src="plugins/moment/moment.min.js"></script>
<script src="plugins/tempusdominus-bootstrap-4/js/tempusdominus-bootstrap-4.min.js"></script>

<!-- datatable js-->
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
<!-- AdminLTE for demo purposes -->
<script src="dist/js/demo.js"></script>
<script>
  "use strict";
  $(document).ready(function() {
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gCOLUMN_ID = 0;
    const gCOLUMN_KICH_CO_COMBO = 1;
    const gCOLUMN_lOAI_PIZZA = 2;
    const gCOLUMN_NUOC_UONG = 3;
    const gCOLUMN_THANH_TIEN = 4 ;
    const gCOLUMN_HO_VA_TEN = 5;
    const gCOLUMN_SO_DIEN_THOAI = 6;
    const gCOLUMN_TRANG_THAI = 7;
    const gCOLUMN_DETAIL = 8;
    // Định nghia columns name
    // declare a vaicable contain data from sever side
    const gUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
    var gOrderArray = [];
    var gId = "";
    var gOrderId = "";
    const gCOL_NAM_ARRAY = ["id","kichCo","loaiPizza","idLoaiNuocUong","thanhTien", "hoTen","soDienThoai","trangThai", "detail" ];
    // declare array contain Combo object
    var gComBoArray = [{
      kichCo: "M",
      duongKinh: 25,
      suon: 4,
      salad: "300",
      soLuongNuoc: 3,
      thanhTien: 200000,
    },
    {
      kichCo: "S",
      duongKinh: 20,
      suon: 2,
      salad: "200",
      soLuongNuoc: 2,
      thanhTien: 150000,
    },
    {
      kichCo: "L",
      duongKinh: 30,
      suon: 8,
      salad: "500",
      soLuongNuoc: 4,
      thanhTien: 250000,
    }
  ]
    
    // định nghĩa table  - chưa có data
    var gOrderTable = $("#user-table").DataTable( {
      // Khai báo các cột của datatable
      "columns" : [
          { "data" : gCOL_NAM_ARRAY[gCOLUMN_ID]},
          { "data" : gCOL_NAM_ARRAY[gCOLUMN_KICH_CO_COMBO]},
          { "data" : gCOL_NAM_ARRAY[gCOLUMN_lOAI_PIZZA]},
          { "data" : gCOL_NAM_ARRAY[gCOLUMN_NUOC_UONG]},
          { "data" : gCOL_NAM_ARRAY[gCOLUMN_THANH_TIEN]},
          { "data" : gCOL_NAM_ARRAY[gCOLUMN_HO_VA_TEN]},
          { "data" : gCOL_NAM_ARRAY[gCOLUMN_SO_DIEN_THOAI]},
          { "data" : gCOL_NAM_ARRAY[gCOLUMN_TRANG_THAI]},
          { "data" : gCOL_NAM_ARRAY[gCOLUMN_DETAIL]},
      ],
      // Ghi đè nội dung của cột action, chuyển thành button chi tiết
      "columnDefs": [ 
      {
          "targets": gCOLUMN_DETAIL,
          "defaultContent": `
          <i class="fas fa-edit edit-icon edit-icon" title="detail"></i>
          <i class="fas fa-trash-alt delete-icon" title="delete"></i>
          `,
      }]
    });
    
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    onPageLoading();
    $(".btn-filter-order").click(function(){
      onBtnFilterClick(this);
    });
    $(".btn-add-order").click(function(){
      onBtnAddOrderClick(this);
    });
    $(document).on("click" ,".edit-icon", function(){
      onBtnEditIconClick(this);
    });
    $(document).on("click" ,".delete-icon", function(){
      onBtnDeleteIconClick(this);
    });
    $(document).on("click" ,"#btn-confirm", function(){
      onBtnConfirmOrderClick(this);
    });
    $(document).on("click" ,"#btn-cancel", function(){
      onBtnCancelOrderClick(this);
    });
    $(document).on("click" ,"#btn-add", function(){
     onBtnAddClick(this)
    });
    $(document).on("click" ,".btn-yes", function(){
     onBtnYesClick(this)
    });
    $(document).on("change", "#select-combo-add" ,function(){
     onBtnSelectSizePizzaChange(this)
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
    // hàm chạy khi trang được load
    function onPageLoading() {
      // lấy data từ server
      $.ajax({
        url: "http://203.171.20.210:8080/devcamp-pizza365/orders",
        type: "GET",
        dataType: 'json',
        success: function(responseObject){
          //debugger;
          gOrderArray = responseObject;
          loadDataToTable(gOrderArray);
        },
        error: function(error){
          console.assert(error.responseText);
        }
      });
    }

    // function on Btn filter Click 
    function onBtnFilterClick(paramFilter) {
      debugger
      // step 0 : declare a object contain data that is meed filter
      // step 1: get data 
      var vFilterObject = {
        loaiPizza: $("#inp-loai-pizza option:selected").text(),
        trangThai: $("#inp-order-status option:selected").text(),
      }
      // step 2: validate (no need in situation)
      // step 3: handle font-end
      var vResult = filterData(vFilterObject);
      loadDataFilterToTable(vResult);

    }
    
    // funciton handle event when click icon 
    function onBtnEditIconClick(paramIcon) {
      // get Id or order Code
      gId = gOrderTable.row($(paramIcon).parents("tr")).data().id;
      gOrderId = gOrderTable.row($(paramIcon).parents("tr")).data().orderCode;
      console.log(gId);
      console.log(gOrderId);
      // show modal 
      $("#modal-confirm-order").modal("show");
      // load da form sever to modal 
      loadDataFromSeverToModal(gId,gOrderId);
    }

    // funtion handle event on Btn confirm click on modal-detail
    function onBtnConfirmOrderClick(paramConfirm){
      // step 1: get Data
      var vUpdateStatus = {
        trangThai: "confirmed"
      }
      //step 2 validate data (no need )
      // step 3: call api to update data
      $.ajax({
        type: "PUT",
        data: JSON.stringify(vUpdateStatus),
        url: gBASE_URL+ "/" + gId,
        contentType: gUTF8_TEXT_APPLICATION_HEADER,
        dataType: "json",
        success: function(data){
          // anoucese to at screen 
          alert("ordering success")
          console.log("new objec is ")
          console.log(data);
          //add updated object to datatabe
          debugger
          updateObject(data)
          loadDataToTable(gOrderArray)
          // hida the modal 
          $("#modal-confirm-order").modal("hide");
        },
        error: function(jXhr) {
          console.log("faile error " + " " + jXhr.status)
        }
      })
    }
 
    // funtion handle event on Btn cancel click on modal-detail
    function onBtnCancelOrderClick(paramCancel){
      // step 1: get Data
      var vUpdateStatus = {
        trangThai: "cancel"
      }
      //step 2 validate data (no need )
      // step 3: call api to update data
      $.ajax({
        type: "PUT",
        data: JSON.stringify(vUpdateStatus),
        url: gBASE_URL+ "/" + gId,
        contentType: gUTF8_TEXT_APPLICATION_HEADER,
        dataType: "json",
        success: function(data){
          // annouces to at screen 
          alert("cancel success")
          console.log( "id is: " + gId)
          console.log("new objec is ")
          console.log(data);
          //add updated object to datatabe
          debugger
          updateObject(data)
          loadDataToTable(gOrderArray)
          // hida the modal 
          $("#modal-confirm-order").modal("hide");
        },
        error: function(jXhr) {
          console.log("faile error " + " " + jXhr.status)
        }
      })
    }
     
    // function handle event display element coressponding with combo chose S , M , L
    function onBtnSelectSizePizzaChange(paramSelect) {
      console.log("lấy được select");
      console.log(paramSelect);
      var vSelectValue = $(paramSelect).val();
      console.log(vSelectValue)
      gComBoArray.forEach(combo => {
        if(vSelectValue == combo.kichCo) {
          $("#inp-diameter-pizza-add").val(combo.duongKinh);
          $("#inp-suon-add").val(combo.suon);
          $("#inp-so-luong-do-uong-add").val(combo.soLuongNuoc);
          $("#inp-salad-add").val(combo.salad);
          $("#inp-prices-add").val(combo.thanhTien);
        }
      })
    }
    
    // fucntion handle event add order click on web
    function onBtnAddOrderClick(paramAddOrder){
      //step 1: show modal add
      $("#modal-add-order").modal("show");
      //step 2 : get data to modal 
        // set status of order is default: open
        $("#inp-status-cargo-add").val("open");
        //Date picker
        $('#inp-ngay-tao-add').datetimepicker({
          format: 'L'
        });
        $('#inp-ngay-update-add').datetimepicker({
          format: 'L'
        });
        // loadding data to select drink
        var vSelectDrink = $("#select-do-uong-add")
        loadDataToSelectDrink(vSelectDrink);

    }
    
    // function handle event button add on click at modal-add
    function onBtnAddClick(paramAdd) {
      //base url
      const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";  
      // step 1: get data
      var vNewOrder = {
        kichCo: $("#select-combo option:selected").val(),
        duongKinh: $("#inp-diameter-pizza-add").val(),
        suon: $("#inp-suon-add").val(),
        salad: $("#inp-salad-add").val(),
        loaiPizza: $("#select-loai-pizza-add").val(),
        idVourcher: $("#inp-voucher-id-add").val(),
        idLoaiNuocUong: $("#select-do-uong-add").val(),
        soLuongNuoc: $("#inp-so-luong-do-uong-add").val(),
        hoTen: $("#inp-ho-ten-add").val(),
        thanhTien: $("#inp-prices-add").val(),
        email: $("#inp-email-add").val(),
        soDienThoai: $("#inp-phone-add").val(),
        diaChi: $("#inp-dia-chi-add").val(),
        loiNhan: $("#inp-loi-nhan-add").val(),
      }  
      // step 2: validate data
      var vCheck = validateAddNewOrder(vNewOrder)
      // step 3: call api to add new order
      if(vCheck){
        // call api to create new order
        $.ajax({
            type: "POST",
            url: vBASE_URL,
            data: JSON.stringify(vNewOrder),// now data come in this function
            contentType: gUTF8_TEXT_APPLICATION_HEADER,
            crossDomain: true,
            dataType: "json",
            success: function (data, status, jqXHR) {
              console.log(data);
              alert("add new order success"); // anounce success
              gOrderArray.push(data) // add object return from sever to array
              // reaload DataTable again
              reloadDatatable(gOrderArray)
              //reset modal-add
              resetModalAddForm()
              // hide modal-add
              $("#modal-add-order").modal("hide");
            },
            error: function (jqXHR, status) {
                // error handler
                console.log(jqXHR);
                alert('fail' + jqXHR.status);
            }
 });
      }
    }
    
    // function handle event on delete icon click
    function onBtnDeleteIconClick(paramDeleteIcon) {
      // get Id or order Code
      gId = gOrderTable.row($(paramDeleteIcon).parents("tr")).data().id;
      gOrderId = gOrderTable.row($(paramDeleteIcon).parents("tr")).data().orderCode;
      console.log('lấy được id and và ordercOde')
      console.log("id" + " " + gId);
      console.log("order code" + " " + gOrderId);
      // show modal 
      $("#modal-delete-order").modal("show");
    }

    // funciton hanlde event on btn yes click on modal-delete
    function onBtnYesClick(paramYes) {
      // step 1: get data
      // step 2: validate
      // step 3: call api to delete order
      $.ajax({
        url: gBASE_URL + "/" + gId,
        type: 'DELETE',
        dataType: 'json', // added data type
        success: function(result){
          // delete user table on databale client side
          deleteOrder(gOrderId)
          alert("delete success ")
          //reload dataTable
          loadDataToTable(gOrderArray)
          //hide mode
          $("#modal-delete-order").modal("hide");
        },

        error: function(jqXHR,status, error){
        // error handler
          console.log(jqXHR);
          alert('fail' + status.code);
        },
      });
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
    // load data to table
    function loadDataToTable(paramOrderArray) {
      //Xóa toàn bộ dữ liệu đang có của bảng
      gOrderTable.clear();
      //Cập nhật data cho bảng 
      gOrderTable.rows.add(paramOrderArray);
      //Cập nhật lại giao diện hiển thị bảng
      gOrderTable.draw();
    }

    // funtion loading data filtered to table
    function loadDataFilterToTable(paramOrderArray) {
      //Xóa toàn bộ dữ liệu đang có của bảng
      gOrderTable.clear();
      //Cập nhật data cho bảng 
      gOrderTable.rows.add(paramOrderArray);
      //Cập nhật lại giao diện hiển thị bảng
      gOrderTable.draw();
    }
  
    // filter function 
    function  filterData(paramFilterObject){
      var vResult = [];
      debugger
      if(paramFilterObject.loaiPizza == "(all)" &&paramFilterObject.trangThai == "(all)") {
        vResult = gOrderArray
      } else if (paramFilterObject.loaiPizza == "(all)" && paramFilterObject.trangThai != "(all)"){
          gOrderArray.forEach(object => {
            if(object.trangThai == paramFilterObject.trangThai){
                vResult.push(object)
              }
          })
        }
        else if (paramFilterObject.loaiPizza != "(all)" && paramFilterObject.trangThai == "(all)"){
          gOrderArray.forEach(object => {
            if(object.loaiPizza == paramFilterObject.loaiPizza){
                vResult.push(object)
              }
          })
        }
        else if (paramFilterObject.loaiPizza != "(all)" && paramFilterObject.trangThai != "(all)"){
          gOrderArray.forEach(object => {
            if(object.loaiPizza == paramFilterObject.loaiPizza &&
               object.trangThai == paramFilterObject.trangThai){
                vResult.push(object)
              }
          })
        }
      console.log(vResult);
      return vResult;
    }

    // function show data on modal-edit
    function loadDataFromSeverToModal(){
      //step 1:  get all tag input
      var vInputElement = $("#modal-confirm-order input")
      console.log("test length of input array")
      console.log(vInputElement.length)
      console.log(vInputElement[0])

      // step 2: validate (no need)
      // step 3:  call Api to get data from sever
      $.ajax({
        url: "http://203.171.20.210:8080/devcamp-pizza365/orders" + "/" + gOrderId,
        type: "GET",
        dataType: 'json',
        success: function(responseObject){
          console.log(" get data success")
          console.log(responseObject)
            $("#inp-discount").attr("disabled","disabled")
            vInputElement[0].value = responseObject.orderCode
            vInputElement[0].setAttribute("disabled", false);
            vInputElement[1].value = responseObject.kichCo
            vInputElement[1].setAttribute("disabled", false);
            vInputElement[2].value = responseObject.duongKinh
            vInputElement[2].setAttribute("disabled", false);
            vInputElement[3].value = responseObject.suon
            vInputElement[3].setAttribute("disabled", false);
            vInputElement[4].value = responseObject.idLoaiNuocUong
            vInputElement[4].setAttribute("disabled", false);
            vInputElement[5].value = responseObject.soLuongNuoc
            vInputElement[5].setAttribute("disabled", false);
            vInputElement[6].value = responseObject.idVourcher
            vInputElement[6].setAttribute("disabled", false);
            vInputElement[7].value = responseObject.loaiPizza
            vInputElement[7].setAttribute("disabled", false);
            vInputElement[8].value = responseObject.salad
            vInputElement[8].setAttribute("disabled", false);
            vInputElement[9].value = responseObject.thanhTien
            vInputElement[9].setAttribute("disabled", false);
            vInputElement[11].value = responseObject.hoTen
            vInputElement[11].setAttribute("disabled", false);
            vInputElement[12].value = responseObject.email
            vInputElement[12].setAttribute("disabled", false);
            vInputElement[13].value = responseObject.soDienThoai
            vInputElement[13].setAttribute("disabled", false);
            vInputElement[14].value = responseObject.diaChi
            vInputElement[14].setAttribute("disabled", false);
            vInputElement[15].value = responseObject.loiNhan
            vInputElement[15].setAttribute("disabled", false);
            vInputElement[16].value = responseObject.trangThai
            vInputElement[17].value = responseObject.ngayTao
            vInputElement[17].setAttribute("disabled", false);
            vInputElement[18].value = responseObject.ngayCapNhat
            vInputElement[18].setAttribute("disabled", false);
        },
        error: function(error){
          console.assert(error.responseText);
        }
      });
    }
    
    // function update status of order
    function updateObject(paramData) {
      var vOrderIndex = getIndexFromOerderID()
      gOrderArray.splice(vOrderIndex,1,paramData)
    }

    // funciton get order Index from id
    function getIndexFromOerderID(){
      var vFound = false;
      var vCount = 0
      var vIndex = -1
      while(!vFound, vCount < gOrderArray.length) {
        if(gOrderArray[vCount].id == gId) {
          vIndex = vCount;
          vFound = true;
        };
        vCount++;
      }
      return vIndex; 
    }

    // function validate new order created
    function validateAddNewOrder(paramNewOrder) {
      if(paramNewOrder.kichCo == 0) {
        alert("you not chose the Combo");
        return false;
      };
      if(paramNewOrder.loaiPizza == 0) {
        alert("you not chose the pizza type");
        return false;
      };
      if(paramNewOrder.idLoaiNuocUong == 0) {
        alert("you not chose the drink");
        return false;
      };
      if(paramNewOrder.diaChi == 0) {
        alert("you not fill address");
        return false;
      };
      if(paramNewOrder.soDienThoai == 0) {
        alert("you not fill the phone number");
        return false;
      };
      if(paramNewOrder.hoTen == 0) {
        alert("you not fill the your name");
        return false;
      };
      debugger
      if(paramNewOrder.hoTen == 0) {
        alert("you not fill the your name");
        return false;
      };
      if(paramNewOrder.email != "") {
        if(validateEmail(paramNewOrder.email) == false ) {
          alert("email not valid");
          return false;
        };
      }
      return true;
    } 

    // function loading data to select drink on modal-add
    function loadDataToSelectDrink(paramSelectDrink){
      "use strict";
      var vBASE_URL ="http://203.171.20.210:8080/devcamp-pizza365/drinks";
      // call api to get data
      $.ajax({
        url: vBASE_URL,
        type: "GET",
        dataType: "json",
        success: function(data){
          console.log("Drink array return form sever")
          console.log(data);
            $("<option>",{
            value: 0,
            text: "== Select Drink =="
            }).appendTo(paramSelectDrink)
          data.forEach(drink => {
            $("<option>",{
            value: drink.maNuocUong,
            text: drink.tenNuocUong,
            }).appendTo(paramSelectDrink)
          })

        },
        error: function(jqXHR) {
          alert("fali: " + " " + jqXHR.status)
        }
      })
    }
 
    // eamil validate
    function validateEmail(email) {
    const validate = function(email) {
        return email.match(
            /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/
        );
    };
        if (validate(email)) {
            return true;
        } else {
            return false
        }
    }
    
    // function reset modal add form 
    function resetModalAddForm() {
      $("#select-combo-add option").first().prop('selected', true),
      $("#select-loai-pizza-add option").first().prop('selected', true),
      $("#inp-voucher-id-add").val(""),
      $("#select-do-uong-add option").first().prop('selected', true),
      $("#inp-ho-ten-add").val(""),
      $("#inp-email-add").val(""),
      $("#inp-phone-add").val(""),
      $("#inp-dia-chi-add").val(""),
      $("#inp-loi-nhan-add").val(""),
      $("#inp-id-don-hang-add").val("");
      $("#inp-discount-add").val("");
      $("#inp-prices-add").val("");
      $("#inp-prices-add").val("");
      $("#inp-salad-add").val("");
      $("#inp-so-luong-do-uong-add").val("");
      $("#inp-suon-add").val("");
      $("#inp-diameter-pizza-add").val("");
      $("#inp-ngay-tao-add").find("input").val("");
      $("#inp-ngay-update-add").find("input").val("");
    }
    
    // fucntion reload data table 
    function reloadDatatable(paramOrderArray) {
      gOrderTable.clear();
      gOrderTable.rows.add(paramOrderArray)
      gOrderTable.draw();
    }
    
  // function delelte user
  function deleteOrder(paramOrderId) {
    var vOrderIndex = getIndexFromOerderID(paramOrderId);
    gOrderArray.splice(vOrderIndex, 1);
  }
 });
</script>

</html>
